## sp-smaps 0.1.8

=== Makefile ===
# This file is part of sp-smaps.
#
# Copyright (C) 2004-2007 by Nokia Corporation
#
# Contact: Eero Tamminen <eero.tamminen@nokia.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License 
# version 2 as published by the Free Software Foundation. 
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
# 02110-1301 USA


# =============================================================================
# File: Makefile
# 
# Author: Simo Piiroinen
# 
# -----------------------------------------------------------------------------
#
# History:
#
# 18-Jan-2007 Simo Piiroinen
# - sp_smaps_filter added to package
#
# 07-Apr-2006 Simo Piiroinen
# - added symlinking for multimode postprocessor
#
# 12-Sep-2005 Simo Piiroinen
# - added sp_smaps_diff
#
# 09-Sep-2005 Simo Piiroinen
# - added C version of sp_smaps_snapshot
#
# 07-Jul-2005 Simo Piiroinen
# - copied from sp-memtransfer
# =============================================================================

# -----------------------------------------------------------------------------
# Directory Configuration
# -----------------------------------------------------------------------------

NAME   ?= sp-smaps-visualize
ROOT   ?= /tmp/$(NAME)-testing
PREFIX ?= /usr
BIN    ?= $(PREFIX)/bin
DLL    ?= $(PREFIX)/lib/tracktools
MAN1   ?= $(PREFIX)/share/man/man1

# -----------------------------------------------------------------------------
# Common Compiler Options
# -----------------------------------------------------------------------------

CFLAGS += -Wall
CFLAGS += -std=c99
CFLAGS += -D_GNU_SOURCE
CFLAGS += -D_THREAD_SAFE
CFLAGS += -Werror

BUILD  ?= final

ifeq ($(BUILD),final)
CFLAGS  += -Os
LDFLAGS += -s
endif

ifeq ($(BUILD),debug)
CFLAGS  += -O0
CFLAGS  += -fno-inline
CFLAGS  += -g
LDFLAGS += -g
endif

ifeq ($(BUILD),gprof)
CFLAGS  += -O0
CFLAGS  += -g -pg
LDFLAGS += -g -pg
endif

# -----------------------------------------------------------------------------
# Measurement Package Files
# -----------------------------------------------------------------------------
 
BIN_MEASURE += sp_smaps_snapshot

MAN_MEASURE += $(patsubst %,%.1.gz,$(BIN_MEASURE))
MAN_MEASURE += $(patsubst %,%.1.gz,$(DLL_MEASURE))
ALL_MEASURE += $(DLL_MEASURE) $(BIN_MEASURE) $(MAN_MEASURE)

# -----------------------------------------------------------------------------
# Normalization Package Files
# -----------------------------------------------------------------------------
 
# -----------------------------------------------------------------------------
# Visualization Package Files
# -----------------------------------------------------------------------------
 
## QUARANTINE BIN_VISUALIZE += sp_smaps_normalize
## QUARANTINE BIN_VISUALIZE += sp_smaps_analyze
## QUARANTINE BIN_VISUALIZE += sp_smaps_diff

BIN_VISUALIZE += sp_smaps_analyze

LNK_VISUALIZE += sp_smaps_flatten
LNK_VISUALIZE += sp_smaps_normalize
LNK_VISUALIZE += sp_smaps_appvals
LNK_VISUALIZE += sp_smaps_diff

MAN_VISUALIZE += $(patsubst %,%.1.gz,$(BIN_VISUALIZE))
MAN_VISUALIZE += $(patsubst %,%.1.gz,$(DLL_VISUALIZE))
MAN_VISUALIZE += $(patsubst %,%.1.gz,$(LNK_VISUALIZE))

ALL_VISUALIZE += $(DLL_VISUALIZE) $(BIN_VISUALIZE) $(MAN_VISUALIZE)
ALL_VISUALIZE += $(LNK_VISUALIZE)

BIN_VISUALIZE += sp_smaps_filter

# -----------------------------------------------------------------------------
# Targets From All Packages
# -----------------------------------------------------------------------------

ALL_TARGETS += $(ALL_MEASURE) $(ALL_NORMALIZE) $(ALL_VISUALIZE)

# -----------------------------------------------------------------------------
# Top Level Targets
# -----------------------------------------------------------------------------

.PHONY: build install clean distclean mostlyclean tags

build:: $(ALL_TARGETS)

install:: install-measure install-visualize

mostlyclean::
	$(RM) *.o *~

clean:: mostlyclean
	$(RM) $(ALL_TARGETS)

distclean:: clean
	$(RM) tags

tags::
	ctags *.c *.h

.PHONY: tree stats changelog

tree:: install
	tree $(ROOT)

changelog:
	sp_gen_changelog >$@ *.c *.py *.sh Makefile

# -----------------------------------------------------------------------------
# Installation Macros & Rules
# -----------------------------------------------------------------------------

INSTALL_DIR = $(if $1, install -m755 -d $2/)
INSTALL_MAN = $(if $1, install -m644 $1 $2/)
INSTALL_BIN = $(if $1, install -m755 $1 $2/)
INSTALL_DLL = $(if $1, install -m644 $1 $2/)
INSTALL_HDR = $(if $1, install -m644 $1 $2/)

install-%-man::
	$(call INSTALL_DIR,$^,$(ROOT)$(MAN1))
	$(call INSTALL_MAN,$^,$(ROOT)$(MAN1))
	
install-%-bin::
	$(call INSTALL_DIR,$^,$(ROOT)$(BIN))
	$(call INSTALL_BIN,$^,$(ROOT)$(BIN))

install-%-dll::
	$(call INSTALL_DIR,$^,$(ROOT)$(DLL))
	$(call INSTALL_DLL,$^,$(ROOT)$(DLL))

install-%-hdr::
	$(call INSTALL_DIR,$^,$(ROOT)$(HDR))
	$(call INSTALL_HDR,$^,$(ROOT)$(HDR))

# -----------------------------------------------------------------------------
# Compilation Macros & Rules
# -----------------------------------------------------------------------------

# C -> asm
%.q	: %.c
	$(CC) -S -o $@ $(CFLAGS) $<

# PY -> installable script
%	: %.py
	sp_fix_tool_vers -f$< -o$@
	@chmod a-w $@

# generating MAN pages
%.1.gz : %.1
	gzip -9 -c <$< >$@
%.1    : %
	sp_gen_manfile -c ./$< -o $@
	
# updating static libraries
lib%.a :
	$(AR) ru $@ $^

# dynamic libraries
%.so : %.o
	$(CC) -shared -o $@ $(LDFLAGS) $^ $(LD_LIBS)

# -----------------------------------------------------------------------------
# Measurement Package Installation
# -----------------------------------------------------------------------------

install-measure:: $(addprefix install-measure-,dll bin man)

install-measure-dll:: $(DLL_MEASURE)
install-measure-bin:: $(BIN_MEASURE)
install-measure-man:: $(MAN_MEASURE)

# -----------------------------------------------------------------------------
# Visualization Package Installation
# -----------------------------------------------------------------------------

install-visualize:: $(addprefix install-visualize-,dll bin man lnk)

install-visualize-dll:: $(DLL_VISUALIZE)
install-visualize-bin:: $(BIN_VISUALIZE)
install-visualize-man:: $(MAN_VISUALIZE)
install-visualize-lnk:: $(addprefix $(ROOT)$(BIN)/,$(LNK_VISUALIZE))

# -----------------------------------------------------------------------------
# Target specific Rules
# -----------------------------------------------------------------------------

sp_smaps_snapshot : LDLIBS += -lsysperf
sp_smaps_snapshot : sp_smaps_snapshot.o

$(addprefix $(ROOT)$(BIN)/,$(LNK_VISUALIZE)): sp_smaps_analyze
	$(RM) $@
	ln -s $< $@

$(LNK_VISUALIZE): sp_smaps_analyze
	$(RM) $@
	ln -s $< $@

# -----------------------------------------------------------------------------
# Dependency Scanning
# -----------------------------------------------------------------------------

ifneq ($(MAKECMDGOALS),depend)
include .depend
endif

depend:
	gcc -MM *.c > .depend

# -----------------------------------------------------------------------------
# EOF
# -----------------------------------------------------------------------------

sp_smaps_filter : LDLIBS += -lsysperf -lm
sp_smaps_filter : sp_smaps_filter.o symtab.o

## QUARANTINE build:: sp_smaps_filter

=== debian/changelog ===
sp-smaps (0.1.8) unstable; urgency=low

  * Fixed incorrectly named reference to another manual page in
    sp_smaps_filter and a spelling issue in sp_smaps_analyze
    documentation. Fixes: NB#86493

 -- Eero Tamminen <eero.tamminen@nokia.com>  Mon, 28 Jul 2008 15:10:56 +0300

sp-smaps (0.1.7) unstable; urgency=low

  * Removed an obsolete script from the package.
  * sp_smaps_snapshot manual page cleanup.

 -- Eero Tamminen <eero.tamminen@nokia.com>  Wed, 18 Jun 2008 16:56:10 +0300

sp-smaps (0.1.6) unstable; urgency=low

  * Running sp_smaps_snapshot as a root from serial console caused a
    reboot due to automatic usage of realtime scheduling and elevated
    priority.  This behavior is now optional (-r switch) rather than
    default. Fixes: NB#86016

 -- Eero Tamminen <eero.tamminen@nokia.com>  Tue,  3 Jun 2008 13:56:45 +0300

sp-smaps (0.1.5) unstable; urgency=low

  * sp_smaps_analyze.py: Licencing information inconsistencies fixed.
    Fixes: NB#73435
  * sp_smaps_snapshot.c: Avoid calling basename with /proc/PID/cmdline
    strings that might confuse it
  * Fixes: NB#73438

 -- Eero Tamminen <eero.tamminen@nokia.com>  Wed,  7 Nov 2007 17:34:51 +0200

sp-smaps (0.1.4) unstable; urgency=low

  * Not all changed files were commited while making the previous
    release. Fixing that now.
  * Fixes: NB#59897

 -- Eero Tamminen <eero.tamminen@nokia.com>  Wed, 29 Aug 2007 15:40:50 +0300

sp-smaps (0.1.3) unstable; urgency=low

  * Checked/fixed licensing information and documentation.
  * Fixes: NB#59897

 -- Eero Tamminen <eero.tamminen@nokia.com>  Wed, 29 Aug 2007 15:39:53 +0300

sp-smaps (0.1.2) unstable; urgency=low

  * new postprocessor sp_smaps_filter
  * old python filters retained for compatibility

 -- Eero Tamminen <eero.tamminen@nokia.com>  Thu, 18 Jan 2007 16:11:01 +0200

sp-smaps (0.1.1) unstable; urgency=low

  * Code cleanup & help fixes
  * Source package name change to reflect actual contents

 -- Eero Tamminen <eero.tamminen@nokia.com>  Mon, 10 Apr 2006 14:52:54 +0300

sp-smaps-visualize (0.1.0) unstable; urgency=low
  * The sp_smaps_snapshot tool now interleaves smaps data with data from
    /proc/pid/status and /proc/pid/cmdline. This allows better handling
    of launchers and multimode binaries like busybox.
  * Use of 'head /proc/[1-9]*/smaps > foo.cap' discouraged as it misses
    the extra information provided by sp_smaps_snapshot. The format is
    still tolerated for handling old capture files.
  * New versions of smaps kernels use [heap] and [stack] type filenames
    for smaps output. These are utilized to obtain more fine grained
    type information.
  * The postprocessing scripts are now implemented as one multimode
    python script. This allows users to skip normalization step as
    all analysis tools can grok raw smaps data.
  * The sp_smaps_analyze now writes out also process hierarchy tree to
    make it easier to find processes of interest. Duplicate label rows
    added to long application and library listings.
  * New tool sp_smaps_appvals can be used to obtain essential memory
    figures from all applications in a capture file.
  * The sp_smaps_diff tool can output either csv or html format.  

 -- Eero Tamminen <eero.tamminen@nokia.com>  Fri,  7 Apr 2006 17:59:23 +0300

sp-smaps-visualize (0.0.6) unstable; urgency=low

  * sync to /proc/pid/smaps output changes
  * merged earlier COW changes by Ville Medeiros

 -- Eero Tamminen <eero.tamminen@nokia.com>  Tue, 28 Feb 2006 13:44:37 +0200

sp-smaps-visualize (0.0.5) unstable; urgency=low

  * sp_smaps_diff: 
    - typo fix in --level handling
    - added --min-rank option for output filtering


 -- Eero Tamminen <eero.tamminen@nokia.com>  Mon, 12 Sep 2005 13:21:20 +0300

sp-smaps-visualize (0.0.4) unstable; urgency=low

  * sp_smaps_diff: shows differences between normalized smaps snapshots

 -- Eero Tamminen <eero.tamminen@nokia.com>  Mon, 12 Sep 2005 11:51:17 +0300

sp-smaps-visualize (0.0.3) unstable; urgency=low

  * sp_smaps_snapshot now implemented in C

 -- Eero Tamminen <eero.tamminen@nokia.com>  Fri,  9 Sep 2005 13:22:12 +0300

sp-smaps-visualize (0.0.2) unstable; urgency=low

  * Fixed: sp_smaps_analyze output directory

 -- Eero Tamminen <eero.tamminen@nokia.com>  Thu,  7 Jul 2005 19:16:06 +0300

sp-smaps-visualize (0.0.1) unstable; urgency=low

  * Initial release.

 -- Eero Tamminen <eero.tamminen@nokia.com>  Thu,  7 Jul 2005 18:55:44 +0300

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: sh -*- -----------------------------------------------
# Debian rules for building sp-smaps-visualize
#
# Targets:
#
# binary
#	Creates the DEB binaries
#
# build
#	Compiles the software
#
# install
#	Installs the compiled sw to DEB directories
#
# clean
#	Cleans up everything
#
# History:
# 07-Jul-2005 Simo Piiroinen
# - copied from sp_memxfer
# ----------------------------------------------------------------
#
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

.PHONY: build clean realclean install configure\
        binary-indep binary-arch binary

build:: build-stamp

binary:: binary-indep binary-arch

realclean:: clean

configure::
# nothing to do

#----------------------------------------------------------------
# compiling the software

build-stamp: configure
	dh_testdir
	touch $@

clean::
	dh_testdir
	dh_testroot
	rm -f build-stamp
	-$(MAKE) clean

#----------------------------------------------------------------
# debian cleanup
clean::
	dh_testdir
	dh_testroot
	dh_clean 

#----------------------------------------------------------------
# installation

root_measure=$(CURDIR)/debian/sp-smaps-measure
root_visualize=$(CURDIR)/debian/sp-smaps-visualize

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	$(MAKE) install-measure   ROOT=$(root_measure)
	$(MAKE) install-visualize ROOT=$(root_visualize)

#----------------------------------------------------------------
# architecture-independent files -> DEBIAN dirs

binary-indep: #build install
# nothing to do

#----------------------------------------------------------------
# architecture-dependent files -> DEBIAN dirs

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs changelog
	dh_installdocs
#	dh_installexamples
	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_python
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

## sp-smaps 0.2.2+0m5

=== Makefile ===
--- 
+++ 
@@ -5,28 +5,30 @@
 # Contact: Eero Tamminen <eero.tamminen@nokia.com>
 #
 # This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License 
-# version 2 as published by the Free Software Foundation. 
+# modify it under the terms of the GNU General Public License
+# version 2 as published by the Free Software Foundation.
 #
 # This program is distributed in the hope that it will be useful, but
 # WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 # 02110-1301 USA
 
-
 # =============================================================================
 # File: Makefile
-# 
+#
 # Author: Simo Piiroinen
-# 
+#
 # -----------------------------------------------------------------------------
 #
 # History:
+#
+# 25-Feb-2009 Simo Piiroinen
+# - fixed changelog source list
 #
 # 18-Jan-2007 Simo Piiroinen
 # - sp_smaps_filter added to package
@@ -88,7 +90,7 @@
 # -----------------------------------------------------------------------------
 # Measurement Package Files
 # -----------------------------------------------------------------------------
- 
+
 BIN_MEASURE += sp_smaps_snapshot
 
 MAN_MEASURE += $(patsubst %,%.1.gz,$(BIN_MEASURE))
@@ -98,17 +100,18 @@
 # -----------------------------------------------------------------------------
 # Normalization Package Files
 # -----------------------------------------------------------------------------
- 
+
 # -----------------------------------------------------------------------------
 # Visualization Package Files
 # -----------------------------------------------------------------------------
- 
+
 ## QUARANTINE BIN_VISUALIZE += sp_smaps_normalize
 ## QUARANTINE BIN_VISUALIZE += sp_smaps_analyze
 ## QUARANTINE BIN_VISUALIZE += sp_smaps_diff
 
-BIN_VISUALIZE += sp_smaps_analyze
-
+BIN_VISUALIZE += sp_smaps_filter
+
+LNK_VISUALIZE += sp_smaps_analyze
 LNK_VISUALIZE += sp_smaps_flatten
 LNK_VISUALIZE += sp_smaps_normalize
 LNK_VISUALIZE += sp_smaps_appvals
@@ -116,7 +119,6 @@
 
 MAN_VISUALIZE += $(patsubst %,%.1.gz,$(BIN_VISUALIZE))
 MAN_VISUALIZE += $(patsubst %,%.1.gz,$(DLL_VISUALIZE))
-MAN_VISUALIZE += $(patsubst %,%.1.gz,$(LNK_VISUALIZE))
 
 ALL_VISUALIZE += $(DLL_VISUALIZE) $(BIN_VISUALIZE) $(MAN_VISUALIZE)
 ALL_VISUALIZE += $(LNK_VISUALIZE)
@@ -157,7 +159,7 @@
 	tree $(ROOT)
 
 changelog:
-	sp_gen_changelog >$@ *.c *.py *.sh Makefile
+	sp_gen_changelog >$@ *.c *.py Makefile
 
 # -----------------------------------------------------------------------------
 # Installation Macros & Rules
@@ -172,7 +174,7 @@
 install-%-man::
 	$(call INSTALL_DIR,$^,$(ROOT)$(MAN1))
 	$(call INSTALL_MAN,$^,$(ROOT)$(MAN1))
-	
+
 install-%-bin::
 	$(call INSTALL_DIR,$^,$(ROOT)$(BIN))
 	$(call INSTALL_BIN,$^,$(ROOT)$(BIN))
@@ -203,7 +205,7 @@
 	gzip -9 -c <$< >$@
 %.1    : %
 	sp_gen_manfile -c ./$< -o $@
-	
+
 # updating static libraries
 lib%.a :
 	$(AR) ru $@ $^
@@ -240,13 +242,11 @@
 sp_smaps_snapshot : LDLIBS += -lsysperf
 sp_smaps_snapshot : sp_smaps_snapshot.o
 
-$(addprefix $(ROOT)$(BIN)/,$(LNK_VISUALIZE)): sp_smaps_analyze
-	$(RM) $@
-	ln -s $< $@
-
-$(LNK_VISUALIZE): sp_smaps_analyze
-	$(RM) $@
-	ln -s $< $@
+$(addprefix $(ROOT)$(BIN)/,$(LNK_VISUALIZE)): sp_smaps_filter
+	ln -fs $< $@
+
+$(LNK_VISUALIZE): sp_smaps_filter
+	ln -fs $< $@
 
 # -----------------------------------------------------------------------------
 # Dependency Scanning
@@ -265,5 +265,3 @@
 
 sp_smaps_filter : LDLIBS += -lsysperf -lm
 sp_smaps_filter : sp_smaps_filter.o symtab.o
-
-## QUARANTINE build:: sp_smaps_filter

=== debian/changelog ===
sp-smaps (0.2.2+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Stanislavs Lielausis <ext-stanislavs.3.lielausis@nokia.com>  Thu, 20 Aug 2009 15:45:31 +0300

sp-smaps (0.2.2) unstable; urgency=low

  * Added support of the new smaps fields - pss, swap, referenced.
  * Fixes: NB#124861

 -- Stanislavs Lielausis <ext-stanislavs.3.lielausis@nokia.com>  Thu, 20 Aug 2009 14:35:22 +0300

sp-smaps (0.2.1+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Fri, 26 Jun 2009 12:11:24 +0300

sp-smaps (0.2.1) unstable; urgency=low

  * Ignore & give a warning for smaps entries that do not match "==>
    /proc/[0-9]+/smaps <==", instead of dying in assert. This fixes
    cases where we have "==> /proc/self/smaps <==". Fixes: NB#124672
  * Dont try to remove threads from old style capture files.


 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Fri, 26 Jun 2009 12:04:48 +0200

sp-smaps (0.2.0) unstable; urgency=low

  * Switch to sp_smaps_filter written in C. Fixes: NB#103757

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Mon, 11 May 2009 16:50:57 +0200

=== debian/control ===
Source: sp-smaps
Section: devel
Priority: optional
Maintainer: Eero Tamminen <eero.tamminen@nokia.com>
Build-Depends: debhelper (>= 4.1.0), python, libsysperf-dev
Standards-Version: 3.6.1

Package: sp-smaps-measure
Architecture: any
Depends: ${shlibs:Depends}
Suggests: 
Description: /proc/pid/smaps snapshot generator
 Utilities for taking snapshots of /proc/pid/smaps memory information.
 . 

Package: sp-smaps-visualize
Architecture: any
Depends: python, ${shlibs:Depends}
Suggests: 
Description: /proc/pid/smaps snapshot analyzer
 Utilities for analyzing /proc/pid/smaps snapshots.
 .

=== debian/rules ===
--- 
+++ 
@@ -53,7 +53,7 @@
 	dh_testdir
 	dh_testroot
 	rm -f build-stamp
-	-$(MAKE) clean
+	$(MAKE) clean
 
 #----------------------------------------------------------------
 # debian cleanup
